//
// hello.mag.45.c
//
// Hall effect magnetic sensing with pin interrupt
// Anders Haldin 2015 Fab Academy
//



#include <avr/io.h>
#include <avr/interrupt.h>



ISR(ANALOG_COMP_vect)
{
 if ((PINB & (1<<PINB1)) == 0)
 {
  PORTB |= (1<<PB1); //turn on LED
 } else {
  PORTB &= ~(1<<PB1); //Turn of LED
 }
}



int main(void) {

   DDRB |= (1<<DDB1); // set as output. set bit in register. LED
   DDRB &= ~(1<<DDB4); // set as input. clear bit in register. HALL
   
   PORTB |= (1<<PB1); // turn off LED (this pard LED is connected to VCC therefore reversed)
//   PORTB |= (1<<PB4); // enable pull up resistor Button
   
   
   GIMSK |= (1<<PCIE); //Enable pin change interrupt.
   PCMSK |= (1<<PCINT5); //pin mask

   sei(); // enable global interrupt

  
   //
   // init A/D converter
   //
   ADMUX = (0 << REFS2) | (0 << REFS1) | (0 << REFS0) // Vcc ref
      | (0 << ADLAR) // right adjust make it 10 bits = 1024 0=0V 1024
      | (0 << MUX3) | (0 << MUX2) | (1 << MUX1) | (0 << MUX0); // (ADC4) PB4 pin
   ADCSRA = (1 << ADEN) // enable 
      | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0); // prescaler /128


   ACSR |= (1<<ACIE); //Analog Comparator Interrupt Enable
   //ACSR |= (1<<ACBG); //Analog Comparator Bandgap Select

   ADCSRA |= (1 << ADSC); // start analog to digital converter

if (ADC )
{
   /* code */
}


   while(1) 
   {
  
   }//closing while loop.

}// closing main